from Products.CMFCore.utils import getToolByName

def setupVarious(context):

    # Ordinarily, GenericSetup handlers check for the existence of XML files.
    # Here, we are not parsing an XML file, but we use this text file as a
    # flag to check that we actually meant for this import step to be run.
    # The file is found in profiles/default.

    if context.readDataFile('plone.app.batch_various.txt') is None:
        return

    # Add additional setup code here

def unSetupVarious(context):

    # Ordinarily, GenericSetup handlers check for the existence of XML files.
    # Here, we are not parsing an XML file, but we use this text file as a
    # flag to check that we actually meant for this import step to be run.
    # The file is found in profiles/default.

    if context.readDataFile('plone.app.batch_various.txt') is None:
        portal = context.getSite()
        print 'Uninstalling plone.app.batch actions'
        provider = getToolByName(portal,'portal_actions').object
        action_id = 'batchsearch'
        if action_id in [action.id for action in provider.listActions()]:
            provider.manage_delObjects(ids=[action_id])
        provider = getToolByName(portal,'portal_controlpanel')
        action_id = 'plone.app.batch'
        action_ids = [action.id for action in provider.listActions()]
        if action_id in action_ids:
            index = action_ids.index(action_id)
            provider.deleteActions(selections=(index,))
        print 'Done'
        return
