from zope import schema
from zope.interface import Interface

from plone.app.batch import BatchMessageFactory as _

class IBatchEditableMarker(Interface):
    """Marker interface that defines Batch editable content types.
    """

class IBatchEditableContentTypes(Interface):
    types = schema.Iterable(title=u'batch_editable_types',
                            description=_(u'A list of batch editable types'))

class IAT2Z3Field(Interface):
    """Interface for getting a zope 3 field from an Archetypes field"""

class IBatchField(Interface):
    """Marker interface for Batch editable fields"""