from DateTime import DateTime
from datetime import datetime

from zope.interface import alsoProvides

from plone.app.batch.interfaces import IBatchField
from plone.app.batch.browser.interfaces import IBatchEditable

def makeBatchEditableField(field):
    field.interface = IBatchEditable
    alsoProvides(field,IBatchField)

def to_datetime(date):
    if isinstance(date,datetime):
        return date
    elif isinstance(date,DateTime):
        date_attrs = ['year','month','day','hour','minute','second']
        date_args = dict([(a,getattr(date,a)()) for a in date_attrs])
        second,microsecond = divmod(date_args['second'],1)
        date_args['microsecond'] = int(microsecond*1000000)
        date_args['second'] = int(second)
        return datetime(**date_args)
    else:
        raise TypeError

def to_DateTime(date):
    if isinstance(date,DateTime):
        return date
    elif isinstance(date,datetime):
        return DateTime(str(date))
    else:
        raise TypeError
